#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>

#define MQ_ALIGNSIZE 8

char *as_binary(uint32_t n) {
  int bit_i = 31;
  char *bits;
  uint64_t on_bit;

  bits = malloc(sizeof(char) * 33);

  for (int i = 0; i < 32; i++, bit_i--) {
    on_bit = 1u << bit_i;
    bits[i] = (on_bit & n) ? '1' : '0';
  }
  bits[32] = '\0';

  return bits;
}

int main(int argc, char **argv) {
  uint32_t size = 0;
  uint32_t temp, a, b;
  size = atoi(argv[1]);

  a = (size + MQ_ALIGNSIZE - 1);
  b = ~(MQ_ALIGNSIZE - 1);
  temp = a & b;

  printf("size: %s (%u)\n", as_binary(size), size);
  printf("   a: %s (%u)\n", as_binary(a), a);
  printf("   b: %s (%u)\n", as_binary(b), b);
  printf("temp: %s (%u)\n", as_binary(temp), temp);

  return 0;
}
